#include <stdio.h>

int main(int argc, char **argv)
{
  (void) argc;
  (void) argv;
  int input;
  int output = 0;
  int shift = 4;
  while (EOF != (input = getchar()))
  {
    if (input & 0xF0)
    {
      fprintf(stderr, "decode4: warning: high nibble ignored\n");
      input &= 0x0F;
    }
    output |= input << shift;
    if (shift == 0)
    {
      putchar(output);
      output = 0;
    }
    shift = 4 - shift;
  }
  return 0;
}
